package eu.maiora.routes

import eu.maiora.model.TessereRepositoryImpl
import io.ktor.http.*
import io.ktor.server.application.*
import io.ktor.server.auth.*
import io.ktor.server.response.*
import io.ktor.server.routing.*


fun Route.tessere(tessereRepository: TessereRepositoryImpl){
    route("/api/tessere"){
        authenticate("auth-jwt") {
            get("{cf}"){
                // Ottieni il codice fiscale dal percorso
                val cf = call.parameters["cf"]

                if (cf == null) {
                    call.respondText("Codice fiscale non valido", status = HttpStatusCode.BadRequest)
                    return@get
                }

                // Cerca la tessera per codice fiscale
                val tessera = tessereRepository.tesseraByCodiceFiscale(cf)

                if (tessera != null) {
                    call.respond(tessera)
                } else {
                    call.respondText("Tessera non trovata", status = HttpStatusCode.NotFound)
                }
            }
        }

    }
}